#ifndef MYDEF_C_H
#define MYDEF_C_H

// ***********************************************************************
// SAVE TYPES
// ***********************************************************************
/*
	Save Conventions:
	     types int & short changes by system 16bit or 32bit
	     to avoid differences between DB files and other objs
	     in save/load functions assumed:
	      char,u_char	8bit
	      short		directly unused
	      int		directrly unused
	      long,u_long	32 bit
	      INT,u_INT		16 bit type instead int,short

	      enum directly conversion to INT based types
	      save( (INT)enum_value );
*/

//Here int 32-bit -same as long
#ifndef Int
typedef short int Int;
#endif
#ifndef Int_p
typedef Int* Int_p;
#endif

#ifndef u_Int
typedef unsigned short int u_Int;
#endif
#ifndef u_Int_p
typedef u_Int* u_Int_p;
#endif

// ***********************************************************************
// STD TYPES
// ***********************************************************************
#ifndef char_p
typedef char* char_p;
#endif
#ifndef u_char
typedef unsigned char u_char;
#endif
#ifndef u_char_p
typedef u_char* u_char_p;
#endif

#ifndef int_p
typedef int* int_p;
#endif
#ifndef u_int
typedef unsigned int u_int;
#endif
#ifndef u_int_p
typedef u_int* u_int_p;
#endif

#ifndef long_p
typedef long *long_p;
#endif
#ifndef u_long
typedef unsigned long u_long;
#endif
#ifndef u_long_p
typedef u_long *u_long_p;
#endif

#ifndef double_p
typedef double *double_p;
#endif
#ifndef float_p
typedef float *float_p;
#endif

#ifndef void_p
typedef void *void_p;
#endif

// ***********************************************************************
#endif