#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <alloc.h>
#include <assert.h>

#include "mydef_c.h"

#include "plist.h"

// *****************************************************************
//
void	t_plist_item_constructor(t_plist_item_p this)
{
	assert(this);

	this->obj_pointer=0;
	this->next=0;
}

// *****************************************************************
//    :
static void  t_plist_insert(t_plist_p this, void*);
//     :
static void  t_plist_remove(t_plist_p this);
//   n:
static void* t_plist_index(t_plist_p this,int);
// :
static void  t_plist_zap(t_plist_p this);

#define check_par()	assert((this->list)&&(this->number < this->items))

// *****************************************************************
//
void	t_plist_constructor(t_plist_p this)
{
	assert(this);

	this->insert=t_plist_insert;
	this->remove=t_plist_remove;
	this->index=t_plist_index;
	this->zap=t_plist_zap;

	this->list=0;
	this->items=0;
	this->number=0;
}

// *****************************************************************
//    :
void 	t_plist_insert(t_plist_p this, void* obj)
{
t_plist_item_p	p,n;
int		i;

	assert(this);
	//    
	assert(obj);

	if(this->items)
	 check_par();
	else
	 assert(!this->number);

	//  
	n=malloc(sizeof(t_plist_item));
	assert(n);
	t_plist_item_constructor(n);
	n->obj_pointer=obj;

	p=this->list;

	//  
	if(!p)
	 {
	  this->list=n;
	  this->items++;
	  this->number=0;
	  return;
	 }

	//goto item "number"
	for(i=0;i<this->number;i++)
	 {
	  p=p->next;
	  assert(p);
	 }

	//?   
	if(p->next)n->next=p->next;

	p->next=n;
	this->number++;
	this->items++;
}

// *****************************************************************
//    :
void 	t_plist_remove(t_plist_p this)
{
t_plist_item_p	p,prev;
int		i;

	assert(this);

	if(!this->items)return;
	check_par();

	prev=0;
	p=this->list;
	assert(p);

	//goto item "number"
	for(i=0;i<this->number;i++)
	 {
	  prev=p;
	  p=p->next;
	  assert(p);
	 }

	if(prev)prev->next=p->next;
	else this->list=p;
	free(p);
	this->items--;
}

// *****************************************************************
//   n:
void*	t_plist_index(t_plist_p this,int item)
{
t_plist_item_p	p;
int		i;

	assert(this);

	if(!this->items)return 0;
	check_par();

	this->number=item;

	p=this->list;
	for(i=0;i<item;i++)
	 {
	  p=p->next;
	  assert(p);
	 }

	return p->obj_pointer;
}

// *****************************************************************
// :
void 	t_plist_zap(t_plist_p this)
{
t_plist_item_p	p,t;
int		i;

	assert(this);

	if(!this->items)return;
	assert(this->list);

	this->number=0;
	p=this->list;
	for(i=0;i<this->items;i++)
	 {
	  assert(p);
	  t=p->next;
	  free(p);
	  p=t;
	 }
	this->items=0;
}

// *****************************************************************
